package fxReseptit;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.MenuItem;
import javafx.scene.control.TextField;
import reseptit.Ainesosa;
import reseptit.Ohje;
import reseptit.Reseptit;
import fi.jyu.mit.fxgui.*;
import javafx.application.Platform;


import javafx.scene.control.TextArea;
import java.util.List;

import java.io.PrintStream;
import fi.jyu.mit.fxgui.ListChooser;
import reseptit.SailoException;


/**
 * @author Omistaja
 * @version 18.2.2025
 * Pääohjelman eli pääikkunan kontrolleri
 */
public class ReseptitGUIController implements ModalControllerInterface<String>{

    @FXML private MenuItem Apua;

    @FXML private MenuItem LisaaAinesosa;

    @FXML private MenuItem Muokkaa;

    @FXML private MenuItem Poista;

    @FXML private MenuItem Sulje;

    @FXML private MenuItem Tiedot;

    @FXML private MenuItem Tulosta;

    @FXML private MenuItem lisaaResepti;
    
    @FXML private ListChooser<Ohje> ReseptiLista;

    @FXML private Button nMuokkaa;

    @FXML private TextField ohjehaku;
    
    @FXML private TextArea TietoKentta;

    @FXML private ListChooser<Ainesosa> chooserOhjeet;
    
    @FXML private TextArea OhjeArea;


    
    
    /**
     * Avaa ikkunan jossa voidaan muokata ainesosalistaa
     */
    @FXML void AvaaAinesosanLisays() {
        ModalController.showModal(AinesosaGUIController.class.getResource("AinesosaGUIView.fxml"), "Ainesosa", null, "");
    }

    
    /**
     * Avaa ikkunan jossa voidaan muokata reseptiä
     */
    @FXML void AvaaReseptinMuokkaus() {
        ModalController.showModal(OhjeetGUIController.class.getResource("OhjeetGUIView.fxml"), "Ohje", null, "");
    }

    @FXML void AvaaReseptinMuokkausTyhjana() {
    //Dialogs.showMessageDialog("Vielä ei osata avata reseptin muokkausta tyhjänä.");
    Lisaa();
    }

    
    /**
     * Avaa ikkunan josta nähdään ohjelman tietoja
     */
    @FXML void AvaaTiedot() {
        ModalController.showModal(TiedotGUIController.class.getResource("TiedtoGUIView.fxml"), "Jäsen", null, "");
    }

    @FXML void PoistaResepti() {
        //Dialogs.showMessageDialog("Vielä ei osata poistaa reseptiä.");
        Lisaa2();
    }
    
    
    /**
     * Hakee hakupalkissa olevan tekstin perusteella ohjetta
     */
    @FXML void HaeOhjetta() {
        String hakukentta = ReseptiLista.getSelectedText();
        String ehto = ohjehaku.getText(); 
        if ( ehto.isEmpty() )
          naytaVirhe(null);
       else
          naytaVirhe("Ei osata vielä hakea " + hakukentta + ": " + ehto);
       
    }
    
    @FXML void Sammutus() {
        Platform.exit();
    }

    @FXML void TulostaResepti() {
        Dialogs.showMessageDialog("Vielä ei osata tulostaa reseptiä.");
    }
    
    @FXML void NaytaOhjeenTiedot() {
        naytaTiedot();
    }

    
    private Reseptit reseptit;
    //private final Collection<Ainesosa> alkiot  = new ArrayList<Ainesosa>();
    
    
    /**
     * @param reseptit mitkä avataan listaan
     */
    public void setReseptit(Reseptit reseptit) {
        
        this.reseptit = reseptit;
        ReseptiLista.addSelectionListener(e -> naytaTiedot());
        hae(0);
    }
    
    
    /**
     * Päivittää ohjelistan
     */
    public void paivita() {
        ReseptiLista.clear();
        for (int i = 0; i<reseptit.getLkm(); i++){
            Ohje s = reseptit.annaOhje(i);
            ReseptiLista.add(s.getNimi(), s);
        }
        
    }
    
    /**
     * Käsittelee virhetekstin, joka tulee näkyviin
     * @param virhe teksti joka tuo virheen
     */
    private void naytaVirhe(String virhe) {
        if ( virhe == null || virhe.isEmpty() ) {
            ohjehaku.setText("");
            ohjehaku.getStyleClass().removeAll("virhe");
            return;
        }
        ohjehaku.setText(virhe);
        ohjehaku.getStyleClass().add("virhe");

    }
   
    
    /**
     *  Lisää reseptilistaan uusia ohjeita
     */
    public void Lisaa() {
        Ohje malli = new Ohje();
        malli.Malliohje();
        try {
            reseptit.lisaa(malli);
        } catch (SailoException ex) {
            System.out.println(" ");
        }
        //reseptit.TestiAinesosat1(malli);
        paivita();
        ReseptiLista.setSelectedIndex(0);
    }
    
    
    /**
     *  Lisää reseptilistaan uusia ohjeita
     */
    public void Lisaa2() {
        Ohje malli2 = new Ohje();
        malli2.Malliohje2();
        try {
            reseptit.lisaa(malli2);
        } catch (SailoException ex) {
            System.out.println(" ");
        }
        reseptit.TestiAinesosat2(malli2);
        paivita();
        ReseptiLista.setSelectedIndex(0);
    }
    
    
    /**
     * Tulostaa ohjeen tiedot
     * @param os tietovirta johon tulostetaan
     * @param ohje tulostettava ohje
     */
    public void tulosta(PrintStream os, final Ohje ohje) {
        os.println("----------------------------------------------");
        ohje.tulosta(os);
        os.println("----------------------------------------------");
        List<Ainesosa> ainesosat = reseptit.annaAinesosat(ohje);
        for (Ainesosa ain:ainesosat)
            ain.tulosta(os);
    }
    
    
    /**
     * Etsii halutun ohjeen
     * @param Ohjeennro etisttävän ohjeen numero
     */
    protected void hae(int Ohjeennro) {
        ReseptiLista.clear();
        OhjeArea.clear();
        
        int index = 0;
        for (int i = 0; i < reseptit.getLkm(); i++) {
            Ohje ohje = reseptit.annaOhje(i);
            if (ohje.getId() == Ohjeennro) index = i;
            ReseptiLista.add(ohje.getNimi(), ohje);
        }
        ReseptiLista.setSelectedIndex(index); // tästä tulee muutosviesti joka näyttää ohjeen
    }    
    
    
    /**
     * Näyttää valitun ohjeen tiedot
     */
    public void naytaTiedot() {
        Ohje ohjeKohdalla = ReseptiLista.getSelectedObject();
        if (ohjeKohdalla == null) return;
        
        chooserOhjeet.clear();
        OhjeArea.clear();
        TietoKentta.clear();

        
        List<Ainesosa> ainesosat = reseptit.annaAinesosat(ohjeKohdalla);
        for(Ainesosa ain : ainesosat) {
            String teksti = "- " + reseptit.getAnimi(ain) + " " + reseptit.getAmaara(ain) + " " + reseptit.getAyksikko(ain);
            chooserOhjeet.add(teksti, ain);
        }
        
        OhjeArea.setText(reseptit.getTeksti(ohjeKohdalla));
        TietoKentta.setText(reseptit.getNimi(ohjeKohdalla) + ": " + reseptit.getAnnoskoko(ohjeKohdalla) + " " + reseptit.getAnnostyyppi(ohjeKohdalla) + ", " + reseptit.getKesto(ohjeKohdalla));
        
    }
    
    /**
     * Kysyy ehtoja avaamiselle, jos niitä olisi
     * @return Voi
     */
    public boolean avaa() {
        return true;
    }

    
    /**
     * Tutkii tallennusta ja sen pohjalta päättää voiko sivun sulkea
     * @return Voi
     */
    public boolean voikoSulkea() {
        // tallenna();
        return true;
    }


    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }


    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }


    @Override
    public void setDefault(String oletus) {
        // TODO Auto-generated method stub
        
    }


    
}
