package fxReseptit;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;
import reseptit.Reseptit;



/**
 * @author Omistaja
 * @version 6.2.2025
 *
 */
public class ReseptitMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            final FXMLLoader ldr = new FXMLLoader(getClass().getResource("ReseptitGUIView.fxml"));
            final Pane root = (Pane)ldr.load();
            final ReseptitGUIController reseptitCtrl = (ReseptitGUIController)ldr.getController();

            final Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("reseptit.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("Reseptit");
            
            // Platform.setImplicitExit(false); // tätä ei kai saa laittaa
            primaryStage.setOnCloseRequest((event) -> {
                if ( !reseptitCtrl.voikoSulkea() ) event.consume();
            });
        
            Reseptit reseptit = new Reseptit();  
            reseptitCtrl.setReseptit(reseptit);

            
        primaryStage.show();
        if ( !reseptitCtrl.avaa() ) Platform.exit();
    } catch(Exception e) {
        e.printStackTrace();
    }

    }


    /**
     * @param args Ei kaytossa
     */
    public static void main(String[] args) {
        launch(args);
    }
}